Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'

%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/jboss/profiler/jvmti/1.0.0.CR5-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

Name:		jboss-profiler
Version:	1.0
Release:	alt1_0.1.CR5.2jpp5
Epoch:		0
Summary:	Log based profiler using JVMPI and JVMTI
License:	LGPLv2+
Group:		Development/Java
URL:		http://labs.jboss.com/portal/jbossprofiler

# cvs -z3 -d:pserver:anonymous@anoncvs.forge.jboss.com:/cvsroot/jboss export -r JBPROFILER_CR5 jboss-profiler
# mv jboss-profiler jboss-profiler-1.0.CR5
# tar -zcf jboss-profiler-1.0.CR5.tar.gz jboss-profiler-1.0.CR5
Source0:	jboss-profiler-1.0.CR5.tar.gz
Source1:	jboss-profiler-jvmti-component-info.xml

Patch0:		jboss-profiler-ChartView.patch
Patch1:		jboss-profiler-ServletUpload.patch
Patch2:		jboss-profiler-ServletUploadFile.patch
Patch3:		jboss-profiler-GraphApplet.patch
Patch4:		jboss-profiler-GraphMemoryApplet.patch
Patch5:		jboss-profiler-project_properties.patch
Patch6:         jboss-profiler-jfreechart-StandardPieToolTipGenerator.patch

BuildArch:	noarch

BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: ant >= 0:1.6
BuildRequires: ant-junit
BuildRequires: ant-nodeps
BuildRequires: jboss-aop
BuildRequires: jboss-common
BuildRequires: gnu-trove
BuildRequires: struts
BuildRequires: servletapi5
BuildRequires: jakarta-commons-beanutils
BuildRequires: jakarta-commons-fileupload
BuildRequires: jakarta-poi
BuildRequires: jcommon
BuildRequires: jfreechart
BuildRequires: jgraph
BuildRequires: junit

Requires: jpackage-utils >= 0:1.6


%description
JBoss Profiler is a log based profiler using JVMPI and JVMTI. 
It uses an agent written in C that captures events from the
JVM and logs them to disk. A web application running on JBoss
or another machine can be used to analyze these logs through a
web browser.
Using log files is especially useful for server application
analysis. Creating profiling snapshots without the need of a
front-end near the JVM means the data can be analyzed#
remotely.
Imagine if your application server slows down and you don't know
why. Why should you have to install a complex tool environment or
have to send data through an open port, breaking firewall rules
between the profiler front-end and the JVMPI/JVMTI JBoss Profiler
can be easily run though your web browser instead.

NOTE: You may have to add a few things on the classpath for running the
profiler console (jgraph, jfreechart, jcommon...).
The AS should provide what is needed for the data # collection during run-time.


%package webapps
Summary:        WARs, SARs, Applet for %{name}
Group:          Development/Java
Requires: %{name} = %{epoch}:%{version}-%{release}

%description webapps
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}

%if %{with_repolib}
%package jvmti-repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	         Development/Java

%description jvmti-repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -q -n %{name}-%{version}.CR5
chmod -R go=u-w *
# Clean up jars
find . -name "*.jar" | xargs %{__rm}

# FIXME should not be needed if an export is used
find . -depth -type d -name CVS -exec rm -r {} \;

%{__perl} -pi -e 's/\r$//g' docs/wiki/JBossProfilerDocumentation.wiki docs/Tutorials/readme.txt

%if %{with_repolib}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE1}
%endif

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav
%patch6 -p1

pushd java/libs/aop
ln -sf $(build-classpath jboss-aop/jboss-aop) .
ln -sf $(build-classpath jboss-common/jboss-common) .
ln -sf $(build-classpath gnu-trove) .
popd
pushd java/libs/web
ln -sf $(build-classpath struts) .
ln -sf $(build-classpath servletapi5) .
ln -sf $(build-classpath commons-fileupload) .
ln -sf $(build-classpath commons-beanutils) .
ln -sf $(build-classpath poi) .
ln -sf $(build-classpath jfreechart) .
ln -sf $(build-classpath jcommon) .
popd
pushd java/libs/appletsLibs
ln -sf $(build-classpath jgraph) .
popd

%build
export CLASSPATH=
export OPT_JAR_LIST="ant/ant-junit junit ant/ant-nodeps"
ant \
	compile \
	jar \
	war \
	console \
	jboss-mbean \
	javah-full \
	javah-lite \
	antProfiler \
	appletjar \

%install

# jar
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -p -m 0644 build/antProfiler.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/antProfiler-%{version}.jar
install -p -m 0644 build/jar/%{name}Engine.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}Engine-%{version}.jar
install -p -m 0644 build/%{name}-jvmti.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-jvmti-%{version}.jar
install -p -m 0644 build/profilerConsole.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/profilerConsole-%{version}.jar
install -p -m 0644 build/profilerSynchronizer.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/profilerSynchronizer-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# webapps
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -p -m 0644 build/aop-monitoring.war $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -p -m 0644 build/applet/graphApplet.jar $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -p -m 0644 build/%{name}-jvmti.sar $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -p -m 0644 build/%{name}-noAOP.sar $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -p -m 0644 build/%{name}.war $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

# manual
install -d -m 0755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
mv "docs/JBossProfiler - JVMTI.doc" "docs/JBossProfiler-JVMTI.doc"
mv "docs/JBoss Profiler ARM.doc" "docs/JBossProfilerARM.doc"
cp -pr docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH2} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH3} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH4} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH5} $RPM_BUILD_ROOT%{repodirsrc}
	cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-profiler-jvmti.jar $RPM_BUILD_ROOT%{repodirlib}
%endif

%files
%{_javadir}/%{name}

%files webapps
%{_datadir}/%{name}-%{version}

%files manual
%{_docdir}/%{name}-%{version}

%if %{with_repolib}
%files jvmti-repolib
%{repodir}
%endif

%changelog
* Fri May 22 2009 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt1_0.1.CR5.2jpp5
- new version

